         title   Splitter32

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \Masm32V1\include\Windows.inc
            include  \Masm32V1\include\user32.inc
            include  \Masm32V1\include\kernel32.inc
            include  \Masm32V1\include\gdi32.inc

       include  \Masm32V1\include\DSPMACRO.asm

         includelib  \Masm32V1\lib\user32.lib
         includelib  \Masm32V1\lib\kernel32.lib
         includelib  \Masm32V1\lib\gdi32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
SplitBarProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SplitProc       PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.data
SplitClassV    db  'SplitClassV',0
SplitClassH    db  'SplitClassH',0

.data?
SplitH         dd  4 dup(?)
SplitV         dd  4 dup(?)
SEditH         dd  4 dup(?)
SEditV         dd  4 dup(?)

hInst          dd  ?
hWnd           dd  ?
hSplitH        dd  ?
hSplitV        dd  ?
hEditH         dd  ?
hEditV         dd  ?
hWnd1          dd  ?
hWnd2          dd  ?
hWnd3          dd  ?
hSplitBar      dd  ?
SplitHAddr     dd  ?
SplitAddr      dd  ?
SplitStyle     dd  ?
BarType        dd  ?
bTop           dd  ?
pTop           dd  ?
pBot           dd  ?
TBHgt          dd  ?
NoTree         dd  ?
QuickOn        dd  ?
FloatOn        dd  ?
xOff           dd  ?
yOff           dd  ?

;===================================================
; DLL initialization section
;===================================================
.code
DllEntry proc hInstance:DWORD, reason:DWORD, reserved1:DWORD
LOCAL    wc:WNDCLASSEX

      .if reason == DLL_PROCESS_ATTACH
            mov     eax, hInstance
            mov     hInst, eax
;---------- [Register our splitter bar classes] ----------
            mov     wc.cbSize,sizeof WNDCLASSEX
            mov     wc.style, CS_GLOBALCLASS
            mov     wc.lpfnWndProc, offset SplitProc
            mov     wc.cbClsExtra, NULL
            mov     wc.cbWndExtra, NULL
            mov     eax, hInstance
            mov     wc.hInstance, eax
            mov     wc.hbrBackground, COLOR_BTNFACE + 1
            mov     wc.lpszMenuName, NULL
            mov     wc.lpszClassName, offset SplitClassV
            mov     wc.hIcon, NULL
            mov     wc.hIconSm, NULL
         INVOKE     LoadCursor, hInst, 898
            mov     wc.hCursor, eax
         INVOKE     RegisterClassEx, addr wc

            mov     wc.lpfnWndProc, offset SplitProc
            mov     wc.lpszClassName, offset SplitClassH
         INVOKE     LoadCursor, hInst, 899
            mov     wc.hCursor, eax
         INVOKE     RegisterClassEx, addr wc

      .elseif reason == DLL_PROCESS_DETACH
;---------- [Unregister our splitter bar classes] ----------
         INVOKE     UnregisterClass, offset SplitClassV, hInstance
         INVOKE     UnregisterClass, offset SplitClassH, hInstance
      .endif
         mov     eax, TRUE
         ret
DllEntry Endp

;===================================================
; Set Handles PROCEDURE
;===================================================
SetHandles PROC hParent:DWORD, hSplitv, hSplith, hEditv, hEdith, hChild1, hChild2, hChild3, StyleSplit, SplitBarH
LOCAL    rect:RECT

        push     StyleSplit
         pop     SplitAddr
        push     hChild3
         pop     hWnd3
        push     hChild2
         pop     hWnd2
        push     hChild1
         pop     hWnd1
        push     hEdith
         pop     hEditH
        push     hEditv
         pop     hEditV
        push     hSplith
         pop     hSplitH
        push     hSplitv
         pop     hSplitV
        push     hParent
         pop     hWnd

;---------- [Load the Splitter array from the parent] ----------
         mov    edx, SplitBarH
         xor     ecx, ecx
      .while (ecx < 16)
            mov     eax, [edx+ecx*4]
            mov     dword ptr SplitH[ecx*4], eax
            inc     ecx
      .endw

;---------- [Determine the SplitStyle] ----------
      INVOKE     GetWindowRect, hWnd, addr rect
         mov     eax, rect.right
         sub     eax, rect.left
         mov     edx, rect.bottom
         sub     edx, rect.top
      .if edx == SplitV[12]
            mov     SplitStyle, 1
         .if SplitH == 0 && SplitH[8] > 0
               mov     SplitStyle, 3
         .elseif SplitH > 0 && SplitH[8] > 0
               mov     SplitStyle, 4
         .endif
      .elseif eax == SplitH[8]
            mov     SplitStyle, 2
         .if SplitV[4] == 0 && SplitV[12] > 0
               mov     SplitStyle, 5
         .elseif SplitV[4] > 0 && SplitV[12] > 0
               mov     SplitStyle, 6
         .endif
      .else
; Do error message
            jmp     NoSplit
      .endif

;---------- [Udate the SplitStyle for the parent] ----------
         mov     ecx, StyleSplit
         mov     eax, SplitStyle
         mov     [ecx], eax

NoSplit:
;---------- [Find the top offset for the client window before sizing] ----------
      INVOKE     GetWindowRect, hWnd1, addr rect ; Rectangle of U/L child
         mov     eax, rect.top
         mov     bTop, eax
;DSPValue hWnd, SplitStyle
;DSPValue hWnd, bTop

         ret
SetHandles Endp

;===================================================
; Set Splitter Bars PROCEDURE
;===================================================
SetSplitBars PROC SplitBarH:DWORD, Notree, Quickon, Floaton, xoff, yoff
LOCAL    rect:RECT
LOCAL    rectP:RECT

        push     yoff
         pop     yOff
        push     xoff
         pop     xOff
        push     Floaton
         pop     FloatOn
        push     Quickon
         pop     QuickOn
        push     Notree
         pop     NoTree
        push     SplitBarH
         pop     SplitHAddr

;---------- [Load the Splitter array from the parent] ----------
         mov    edx, SplitHAddr
         xor     ecx, ecx
      .while (ecx < 16)
            mov     eax, [edx+ecx*4]
            mov     dword ptr SplitH[ecx*4], eax
            inc     ecx
      .endw

         mov     TBHgt, 24
         mov     pTop, 69
         mov     pBot, 63

         ret
SetSplitBars endp

;===================================================
; Splitter Bar PROCEDURE
;===================================================
SplitBarProc PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    hBrush:DWORD

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
         mov     eax, hdlg
         mov     hSplitBar, eax
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_CTLCOLORDLG
         je      ColorDlg
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
         je      CancleIt              ; and if not either of these
         jmp     DlgDone

ColorDlg:
      INVOKE     CreateSolidBrush, 000ff00h
         mov     hBrush, eax
         ret

CancleIt:
      INVOKE     DeleteObject, hBrush
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret                           ; Return
SplitBarProc ENDP

;===================================================
; Splitter PROCEDURE
;===================================================
SplitProc PROC  uses ebx edi  hwnd:DWORD, wmsg, wparam, lparam
LOCAL    rect:RECT
LOCAL    pt:POINT
LOCAL    xPos:DWORD, yPos, hBrush

      .if wmsg == WM_LBUTTONDOWN
         INVOKE     SetCapture, hwnd
            mov     eax, hwnd
            mov     BarType, 1
         .if eax == hSplitV
            mov     BarType, 2
         .elseif eax == hEditH
            mov     BarType, 3
         .elseif eax == hEditV
            mov     BarType, 4
         .endif

      .elseif wmsg == WM_MOUSEMOVE

;---------- [Capture the mouse if within an area] ----------
         INVOKE     GetClientRect, hWnd, addr rect
            mov     eax, lparam
            mov     edx, eax
            and     eax, 0ffffh   
            mov     xPos, eax
            shr     edx, 16
            mov     yPos, edx

         .if wparam == MK_LBUTTON
               mov     eax, xPos
               mov     pt.x, eax
               mov     eax, yPos
               mov     pt.y, eax
            INVOKE     ClientToScreen, hwnd, addr pt
              push     pt.x
              push     pt.y
            INVOKE     GetWindowRect, hWnd, addr rect
               pop     yPos
               pop     xPos
               mov     eax, rect.left
               sub     xPos, eax
               sub     xPos, 6
               and     xPos, 0ffffh

               mov     eax, rect.top
               add     eax, pTop
               sub     yPos, eax
               and     yPos, 0ffffh

            INVOKE     GetClientRect, hWnd, addr rect
               mov     ecx, xPos
               mov     edx, yPos
               mov     eax, pBot
               sub     eax, 2
               sub     rect.bottom, eax
            .if BarType == 3
                  mov     eax, yOff
                  add     rect.top, eax
            .endif
               inc     ecx
               and     ecx, 0ffffh
               inc     rect.right
               add     edx, 2
               and     edx, 0ffffh
            .if ecx > rect.left && ecx < rect.right && edx > rect.top && edx < rect.bottom
            .else
               INVOKE     LoadCursor, 0, IDC_ARROW
               INVOKE     SetCursor, eax
                  jmp     Ret0
            .endif

            .if BarType == 1 || BarType == 3          ; Horizontal splitter
               .if BarType == 1
                     lea     edi, SplitH
               .else
                     lea     edi, SEditH
               .endif
                 push     edi
                  mov     eax, yPos
                  dec     eax
                  mov     [edi+4], eax
                  add     eax, 2
                  mov     [edi+12], eax
                  mov     ecx, SplitV
.if BarType == 3 && NoTree
     xor     ecx, ecx
.endif
.if BarType == 3 && QuickOn
     add     ecx, 33
.endif
.if BarType == 3 && FloatOn && !yOff
     add     ecx, 29
.endif
               .if xPos < ecx && SplitStyle == 3 && BarType == 1 || xPos > ecx && SplitStyle == 4 ||\
                   SplitStyle == 5 || SplitStyle == 6 || SplitStyle < 3 ||\
                   xPos > ecx && SplitStyle == 3 && BarType == 3
                  INVOKE     LoadCursor, hInst, 899
                  INVOKE     SetCursor, eax
                  .if !hSplitBar
                     INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 0
                  .endif
                     mov     eax, yPos
                     add     eax, TBHgt
                     and     eax, 0ffffh
                  .if eax > 7fffh
                        mov     eax, -1
                  .endif
                     pop     edi
                    push     edi
                     mov     [edi+4], eax
                     add     eax, 2
                     mov     [edi+12], eax

                  INVOKE     GetWindowRect, hWnd, addr rect
                     pop     edi
                     add     rect.left, 9 ;6
                     mov     eax, rect.top
                     add     eax, pTop
                     add     eax, [edi+4]
                     sub     eax, TBHgt
                     mov     rect.top, eax
                     mov     eax, [edi]
.if BarType == 3 && NoTree
     xor     eax, eax
.endif
;.if BarType == 3 && QuickOn
;   .if NoTree
;        add     eax, 29 ;30 ;26
;   .else
;        add     eax, 31 ;32 ;28
;   .endif
;.endif
.if BarType == 3
      add     eax, xOff
   .if NoTree
         sub     eax, 2
   .endif
.endif
                     add     rect.left, eax
                     mov     edx, [edi+8]
                     sub     edx, 4
                  .if SplitStyle == 4
                        dec     rect.left
                  .endif
                  INVOKE     MoveWindow, hSplitBar, rect.left, rect.top, edx, 2, TRUE
;                  INVOKE     MoveWindow, hSplitH, SplitH, rect.top, SplitH[8], 1, TRUE
               .else
                  INVOKE     LoadCursor, 0, IDC_ARROW
                  INVOKE     SetCursor, eax
               .endif

            .elseif BarType == 2 || BarType == 4         ; Vertical splitter
               .if BarType == 2
                     lea     edi, SplitV
               .else
                     lea     edi, SEditV
               .endif
                 push     edi
                  mov     eax, xPos
                  dec     eax
;DSPValue hWnd, eax, 1, 't'
                  and     eax, 0ffffh
                  mov     [edi], eax
                  mov     SplitH[8], eax
                  add     eax, 2
                  mov     [edi+8], eax

                  mov     ecx, SplitH[4]
                  mov     edx, SplitV
                  add     edx, 2
;DSPValue hWnd, SEditV, 1, 't'

;.if BarType == 4 && QuickOn
.if BarType == 4
      xor     ebx, ebx
   .if xOff
      mov     ebx, xOff
      sub     ebx, 2
   .endif
      mov     eax, ebx   ;29 ;30 ;29 ;25
      sub     [edi], eax
      sub     [edi+8], eax
.if SEditV > 7ffffh
mov     SEditV, 1
mov     SEditV+8, 3
.endif
.endif

.if BarType == 4 && !NoTree
      mov     eax, SplitV
      sub     [edi], eax
      sub     [edi+8], eax
.if SEditV > 7ffffh
mov     SEditV, 1
mov     SEditV+8, 3
.endif
.endif
.if BarType == 4 && NoTree
     xor     edx, edx
.endif
;.if BarType == 4 && QuickOn
.if BarType == 4
     add     edx, ebx   ;29 ;30 ;29 ;25
.endif

               .if yPos < ecx && SplitStyle == 5 || yPos > ecx && SplitStyle == 6 ||\
                   SplitStyle == 3 && BarType == 2 || SplitStyle == 3 && BarType == 4 && xPos > edx ||\
                   SplitStyle == 4 || SplitStyle < 3
                  INVOKE     LoadCursor, hInst, 898
                  INVOKE     SetCursor, eax
                  .if !hSplitBar
                     INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset SplitBarProc, 0
                  .endif
                     pop     edi
                    push     edi
                     mov     eax, xPos
                     dec     eax
                     mov     [edi], eax
                     add     eax, 2
                     mov     [edi+8], eax
                  INVOKE     GetWindowRect, hWnd, addr rect

                     pop     edi
                     mov     eax, pTop
                     sub     eax, TBHgt
                     inc     eax
.if BarType == 4
      add     eax, yOff
.endif
                     add     rect.top, eax
                     mov     eax, [edi+4]
                     add     rect.top, eax

                     add     rect.left, 6
                     mov     ecx, rect.left
                     add     ecx, [edi]
                     inc     ecx
                     mov     edx, [edi+12]
                     sub     edx, 4
.if BarType == 4 && !NoTree
      mov     eax, SplitV
inc     eax
      sub     [edi], eax
      sub     [edi+8], eax
.endif
.if BarType == 4    ;&& QuickOn
   .if !NoTree
         mov     eax, xOff   ;31 ;32 ;31 ;27
   .else
         mov     eax, xOff   ;30 ;31 ;30 ;26
                     dec     eax
   .endif
      sub     [edi], eax
      sub     [edi+8], eax
.endif

                  .if SplitStyle == 5
                        add     edx, 1
                  .endif
;            mov     eax, SplitV[4]
;            add     eax, 7
;            mov     rect.top, eax
                  INVOKE     MoveWindow, hSplitBar, ecx, rect.top, 2, edx, TRUE
;                  INVOKE     MoveWindow, hSplitV, xPos, rect.top, 1, edx, TRUE
               .else
                  INVOKE     LoadCursor, 0, IDC_ARROW
                  INVOKE     SetCursor, eax
               .endif
            .endif
         .endif

      .elseif wmsg == WM_LBUTTONUP
         INVOKE     ReleaseCapture

;---------- [Update the Splitter array for the parent] ----------
            mov    edx, SplitHAddr
            xor     ecx, ecx
         .while (ecx < 16)
               mov     eax, dword ptr SplitH[ecx*4]
               mov     [edx+ecx*4], eax
               inc     ecx
         .endw

;---------- [Restore the cursor] ----------
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
            and     BarType, 0

;---------- [Send the WM_SIZE message to the parent] ----------
         .if hSplitBar
            INVOKE     SplitBarProc, hSplitBar, WM_COMMAND, IDCANCEL, 0
               and     hSplitBar, 0
            INVOKE     GetClientRect, hWnd, addr rect
               mov     edx, rect.bottom
               shl     edx, 16
               mov     ecx, rect.right
               mov     dx, cx
            INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx
         .endif
      .else
         INVOKE     DefWindowProc, hwnd, wmsg, wparam, lparam
            ret
      .endif

Ret0:
            xor     eax, eax
            ret

SplitProc ENDP

end DllEntry 
